=== modified file 'NEWS'
--- NEWS	2008-03-05 13:13:43 +0000
+++ NEWS	2008-03-07 11:46:20 +0000
@@ -42,6 +42,8 @@
 
    * Branch6.generate_revision_history is faster.  (Aaron Bentley)
 
+   * Directory services are now supported.  (Aaron Bentley)
+
   BUGFIXES:
 
     * Disable plink's interactive prompt for password.

=== modified file 'bzrlib/registry.py'
--- bzrlib/registry.py	2008-03-06 14:12:45 +0000
+++ bzrlib/registry.py	2008-03-07 11:46:20 +0000
@@ -168,6 +168,12 @@
         return self._dict[self._get_key_or_default(key)].get_obj()
 
     def get_prefix(self, fullname):
+        """Return an object whose key is a prefix of the supplied value.
+
+        :fullname: The name to find a prefix for
+        :return: a tuple of (object, remainder), where the remainder is the
+            portion of the name that did not match the key.
+        """
         for key, value in self.iteritems():
             if fullname.startswith(key):
                 return value, fullname[len(key):]

=== modified file 'bzrlib/tests/test_registry.py'
--- bzrlib/tests/test_registry.py	2006-10-16 01:50:48 +0000
+++ bzrlib/tests/test_registry.py	2008-03-07 11:46:20 +0000
@@ -187,6 +187,20 @@
                          ], sorted((key, a_registry.get_info(key))
                                     for key in a_registry.keys()))
 
+    def test_get_prefix(self):
+        my_registry = registry.Registry()
+        http_object = object()
+        sftp_object = object()
+        my_registry.register('http:', http_object)
+        my_registry.register('sftp:', sftp_object)
+        found_object, suffix = my_registry.get_prefix('http://foo/bar')
+        self.assertEqual('//foo/bar', suffix)
+        self.assertIs(http_object, found_object)
+        self.assertIsNot(sftp_object, found_object)
+        found_object, suffix = my_registry.get_prefix('sftp://baz/qux')
+        self.assertEqual('//baz/qux', suffix)
+        self.assertIs(sftp_object, found_object)
+
 
 class TestRegistryWithDirs(TestCaseInTempDir):
     """Registry tests that require temporary dirs"""

